#pragma once

#include <Protocols/DefaultProtocolFactory.hpp>

namespace Protocols
{

class WiimoteProtocolFactory final : public DefaultProtocolFactory
{
  SCORE_CONCRETE("73692564-0940-4386-82d6-3d805953eff6")

  QString prettyName() const override;

  Device::DeviceInterface* makeDevice(
      const Device::DeviceSettings& settings,
      const score::DocumentContext& ctx) override;

  const Device::DeviceSettings& defaultSettings() const override;

  Device::ProtocolSettingsWidget* makeSettingsWidget() override;

  QVariant
  makeProtocolSpecificSettings(const VisitorVariant& visitor) const override;

  void serializeProtocolSpecificSettings(
      const QVariant& data,
      const VisitorVariant& visitor) const override;

  bool checkCompatibility(
      const Device::DeviceSettings& a,
      const Device::DeviceSettings& b) const override;
};

}
